﻿Imports Telerik.WinControls.UI.Scheduler.Dialogs

Public Class Form1

    Private updating As Boolean = False

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'SchedulerDataDataSet.Appointments' table. You can move, or remove it, as needed.
        Me.AppointmentsTableAdapter.Fill(Me.SchedulerDataDataSet.Appointments)

        AddHandler Me.RadScheduler1.Appointments.CollectionChanged, AddressOf Appointments_CollectionChanged
    End Sub

    Public Sub SaveChanges()
        Me.updating = True
        Me.AppointmentsTableAdapter.Update(Me.SchedulerDataDataSet.Appointments)
        Me.updating = False
    End Sub

    Private Sub Appointments_CollectionChanged(sender As Object, e As Telerik.WinControls.Data.NotifyCollectionChangedEventArgs)
        If Me.updating Then
            Return
        End If
        Me.SaveChanges()
    End Sub

End Class

'NOTE: this class is not actually used and I have only added it to demonstrate my previous idea.
'Also, note that this approach will not work in all cases, so I suggest using the CollectionChanged event.
Public Class MyEditDialog
    Inherits EditAppointmentDialog

    Private parentForm As Form1

    Public Sub New(parentForm As Form1)
        Me.parentForm = parentForm
    End Sub

    Protected Overrides Sub ApplySettingsToEvent(targetEvent As Telerik.WinControls.UI.IEvent)
        MyBase.ApplySettingsToEvent(targetEvent)
        ' This will not work with new appointments added through the dialog because ApplySettingsToEvent is called before
        ' the new appointments were added to the Appointments collection. You do not need to call this if you are using the above CollectionChanged handler.
        parentForm.SaveChanges()
    End Sub

End Class